#ifndef CONCESSIONARIO_MATRICOLA_H_
#define CONCESSIONARIO_MATRICOLA_H_

#include "AbstractTest.h"
#include "Auto.h"
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

/* sostituire 12345 con il proprio NumeroDiMatricola
 * ovunque, anche nel nome del file */
class Concessionario12345 : public AbstractTest
{
	private:
		vector<Auto> autoVendute;

	public:
		/* - - - - METODI DA IMPLEMENTARE - - - - */


		/* Inserisce un'auto alla fine del vettore autoVendute e ritorna true 
		 * solo a patto che non sia presente gia' un'altra auto con la stessa targa.
		 *
		 * In caso contrario ritorna semplicemente false senza inserirla. */
		virtual bool caricaAuto(Auto a);



		/* Restituisce il prezzo dell'auto piu' costosa.
		 *
		 * Se ancora non e' stata venduta alcuna auto restituisce 0 */
		virtual int dammiPrezzoMassimo();



		/* Restituisce true se tra le auto vendute ve ne sono almeno due
		 * aventi targhe simili.
		 *
		 * Due targhe sono simili se differiscono ESATTAMENTE per un carattere (lettera o numero):
		 * es: "AB123CD" e "AB124CD" sono simili.
		 *
		 * Si assuma che le targhe abbiano tutte lo stesso numero di caratteri */
		virtual bool targheSimili();



		/* Restituisce il numero di auto mediamente vendute in un anno 
		 * 
		 * Se non sono ancora state vendute auto la media e' 0 */
		virtual int mediaAnnualeAutoVendute ();



		/* Restituisce l'anno in cui si sono vendute piu' auto.
		 *
		 * Nel caso vi siano piu' anni aventi tale caratteristica
		 * viene restituito l'anno piu' recente.
		 *
		 * Se non sono state vendute ancora auto viene restituito 1950 */		
		virtual int dammiAnnoMigliorePiuRecente();
	


		/* - - - - METODI DA NON MODIFICARE - - - - */
		Concessionario12345(); //costruttore di default: crea un meteo vuoto
		virtual ~Concessionario12345() {}
		vector<Auto>& getContent();
};

#endif